/**
*
*  Whenever RTIKernelStartsUp it will serve the location of other Manager
*  objects os that RTIAmbassador object can work with them directly.
*  This also allows us to start these managers on different machines.
*
*/
import RTIcap.*;
import npacrti.*;

/*
*/
public class 
RTIKernel  extends _RTIKernelInterfaceImplBase implements RTIDebug
{

    DeclarationManager      decManager ;
    FederationManager       fedManager ;
    ObjectManager           objManager ;
    OwnershipManager        ownManager ;
    TimeManager             timManager ;
    DataDistributionManager datManager ;
    RTIServices             rtiServices ;
    ObjectClassNaming       objNaming;
    InteractionNaming       interNaming;

    /**
    */
    public
    RTIKernel()
    {

       objNaming  = new ObjectClassNaming(); 
       interNaming  = new InteractionNaming(); 
       decManager = new DeclarationManager(objNaming,interNaming);
       fedManager = new FederationManager(objNaming,interNaming);
       objManager = new ObjectManager(objNaming);
       ownManager = new OwnershipManager();
       timManager = new TimeManager();
       datManager = new DataDistributionManager();
       rtiServices = new RTIServices(objNaming,interNaming);
        
    }// end of RTIKernel

    /**
    */
    public FederationManagerInterface 
    getFederationManager() { return fedManager; } 

    /**
    */
    public DeclarationManagerInterface 
    getDeclarationManager() { return decManager; }

    /**
    */
    public ObjectManagerInterface 
    getObjectManager() { return objManager; }

    /**
    */
    public OwnershipManagerInterface 
    getOwnershipManager() { return ownManager; }

    /**
    */
    public DataDistributionManagerInterface 
    getDataDistributionManager() { return datManager; }

    /**
    */
    public TimeManagerInterface 
    getTimeManager() { return timManager; }

    /**
    */
    public RTIServicesInterface 
    getRTIServices() { return rtiServices; }

    /**
    */
    public String 
    getVersion() { return "RTI Kernel 0.0.1 for spec HLA 1.3 " ; }

    /**
    */
    public RTIcap.RTIambassador 
    createRTIAmbassador() 
    { 
       if(DEBUG) System.out.println(" in createRTIAmbassador() ");
       return new RTIAmb(this); 
    }

}// end of RTIKernel
